accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from django.contrib.auth.views import LoginView, LogoutView
from accounts.views import signup


urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views


urlpatterns = [
    path('admin/', admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("accounts/", include("accounts.urls")),
    path("",
        RedirectView.as_view(url=reverse_lazy("receipts_list_url")), name = "home"
    ),
]

receipts/urls.py
from django.urls import path
from receipts.views import (
    ReceiptListView,
    ReceiptCreateView,
    ReceiptUpdateView,
    ReceiptDeleteView,
    CategoryListView,
    CategoryCreateView,
    CategoryUpdateView,
    CategoryDeleteView,
    AccountListView,
    AccountCreateView,
    AccountUpdateView,
    AccountDeleteView,
)


urlpatterns = [
    path("", ReceiptListView.as_view(), name="receipts_list_url"),
    path("create/", ReceiptCreateView.as_view(), name="receipts_new_url"),
    path("update/<int:pk>/", ReceiptUpdateView.as_view(), name="receipts_edit_url"),
    path("delete/<int:pk>/", ReceiptDeleteView.as_view(), name="receipts_delete_url"),
    path("categories/", CategoryListView.as_view(), name="category_list_url"),
    path("categories/create/", CategoryCreateView.as_view(), name="category_new_url"),
    path("categories/update/<int:pk>/", CategoryUpdateView.as_view(), name="category_edit_url"),
    path("categories/delete/<int:pk>/", CategoryDeleteView.as_view(), name="category_delete_url"),
    path("accounts/", AccountListView.as_view(), name="account_list_url"),
    path("accounts/create/", AccountCreateView.as_view(), name="account_new_url"),
    path("accounts/update/<int:pk>/", AccountUpdateView.as_view(), name="account_edit_url"),
    path("accounts/delete/<int:pk>/", AccountDeleteView.as_view(), name="account_delete_url"),
]

receipts/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# import datetime
# Create your models here.

class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(
        decimal_places=3,
        max_digits=10,
        validators= [
            MinValueValidator(0)
        ],
        )
    tax = models.DecimalField(
        decimal_places=3,
        max_digits=10,
        validators= [
            MaxValueValidator(1.0),
            MinValueValidator(0.0)
        ],
    )
    date = models.DateField(auto_now=False)
    category = models.ForeignKey("ExpenseCategory", related_name="receipts", on_delete=models.CASCADE)
    account = models.ForeignKey("Account", related_name="receipts", on_delete=models.CASCADE)
    owner = models.ForeignKey(USER_MODEL, related_name="receipts", on_delete=models.CASCADE, null=True)

    def __str__(self):
        return "Receipt: " + str(self.vendor)


class Account(models.Model):
    name = models.CharField(max_length=100)
    owner = models.ForeignKey(USER_MODEL, related_name="accounts", on_delete=models.CASCADE, null=True)
    number = models.CharField(max_length=20)

    def __str__(self):
        return "Account: " + str(self.name)


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(USER_MODEL, related_name="categories", on_delete=models.CASCADE, null=True)

    def __str__(self):
        return "Category: " + str(self.name)

receipts/forms.py
from django import forms
from receipts.models import Receipt, Account, ExpenseCategory



class ReceiptForm(forms.ModelForm):
    class Meta:
        model = Receipt
        fields = [
            "vendor",
            "total",
            "tax",
            "date",
            "category",
            "account"
        ]

    def __init__(self, owner, *args, **kwargs):
        super().__init__(*args, **kwargs)
        account = forms.ModelChoiceField(queryset=Account.objects.filter(owner=owner))
        category = forms.ModelChoiceField(queryset=ExpenseCategory.objects.filter(owner=owner))
        self.fields["account"] = account
        self.fields["category"] = category
            

receipts/views.py
from django.shortcuts import render
from django.views.generic import ListView, DetailView, CreateView, DeleteView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from receipts.models import Receipt, ExpenseCategory, Account
from django.urls import reverse_lazy
from receipts.forms import ReceiptForm
from django.conf import settings
USER_MODEL = settings.AUTH_USER_MODEL

# Create your views here.

#receipt views
class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"
    def get_queryset(self):
        return Receipt.objects.filter(owner=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    form_class = ReceiptForm
    template_name = "receipts/new.html"
    success_url = reverse_lazy("receipts_list_url")

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs['owner'] = self.request.user
        return kwargs

    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class ReceiptUpdateView(LoginRequiredMixin, UpdateView):
    model = Receipt
    form_class = ReceiptForm
    template_name = "receipts/edit.html"
    success_url = reverse_lazy("receipts_list_url")
    # fields = [
    #     "vendor",
    #     "total",
    #     "tax",
    #     "date",
    #     "category",
    #     "account",
    # ]

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs['owner'] = self.request.user
        return kwargs


    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class ReceiptDeleteView(LoginRequiredMixin, DeleteView):
    model = Receipt
    template_name = "receipts/delete.html"
    success_url = reverse_lazy("receipts_list_url")



#category views
class CategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "categories/list.html"
    context_object_name = "categories"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user).order_by("name")


class CategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    fields = [
        "name",
    ]
    template_name = "categories/new.html"
    success_url = reverse_lazy("category_list_url")

    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class CategoryUpdateView(LoginRequiredMixin, UpdateView):
    model = ExpenseCategory
    fields = [
        "name",
    ]
    template_name = "categories/edit.html"
    success_url = reverse_lazy("category_list_url")
    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class CategoryDeleteView(LoginRequiredMixin, DeleteView):
    model = ExpenseCategory
    template_name = "categories/delete.html"
    success_url = reverse_lazy("category_list_url")



#account views
class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "accounts/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user).order_by("name")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    fields = [
        "name",
        "number",
    ]
    template_name = "accounts/new.html"
    success_url = reverse_lazy("account_list_url")
    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class AccountUpdateView(LoginRequiredMixin, UpdateView):
    model = Account
    fields = [
        "name",
        "number",
    ]
    template_name = "accounts/edit.html"
    success_url = reverse_lazy("account_list_url")
    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)
    pass


class AccountDeleteView(LoginRequiredMixin, DeleteView):
    model = Account
    template_name = "accounts/delete.html"
    success_url = reverse_lazy("account_list_url")

receipts/templates/receipts/delete.html
{% extends "base.html"%}

{% block content %}
    <main class="center-text-view">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <p>Are you sure you want to delete?</p>
            <button class="button">Delete</button>
        </form>
    </main>
  {% endblock content%}

receipts/templates/receipts/edit.html
{% extends 'base.html' %}

{% block content %}
  <main class="center-text-view">
    <h1>Edit receipt</h1>  
    <p>It is {% now "l, F jS, Y" %}</p>  
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Update Receipt</button>
    </form>
  </main>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends "base.html" %}
{% load cumulative_total %}

{% block content %}
    <main>
    <h1>Receipt{{ receipt_list|pluralize }}</h1>
    <p class="center-text-view">It is {% now "l, F jS, Y" %}</p>
        {% if receipt_list %}
            <table>
                <thead>
                    <th>Vendor</th>
                    <th>Total</th>
                    <th>Tax</th>
                    <th>Purchase Date</th>
                    <th>Category</th>
                    <th>Account</th>
                    <th>Actions</th>
                </thead>
                <tbody>
                    
                    {% for receipt in receipt_list|dictsort:"date" %}
                        {% cycle "grey" "" as rowcolors silent %}
                        <tr>
                            <td class="{{ rowcolors }}">
                                {{receipt.vendor}}
                            </td>
                            <td class="{{ rowcolors }}">${{receipt.total | floatformat:"2g"}}</td>
                            <td class="{{ rowcolors }}">{{receipt.tax | floatformat:2 }}%</td>
                            <td class="{{ rowcolors }}">{{receipt.date | date:"m-d-Y"}}</td>
                            <td class="{{ rowcolors }}">
                                {% filter force_escape | upper %}
                                    {{receipt.category.name}}
                                {% endfilter %}
                            </td>
                            <td class="{{ rowcolors }}">
                                {% filter force_escape | upper %}
                                    {{receipt.account.name}}
                                {% endfilter %}
                            </td>
                            <td>
                                <a href="{% url "receipts_edit_url" receipt.id %}">Edit</a>
                            </td>
                            <td>
                                <a href="{% url "receipts_delete_url" receipt.id %}">Delete</a>
                            </td>
                        </tr>
                    {% endfor %}
                    <tr class="table-total">
                        <td>Total: </td>
                        <td>${{ receipt_list|cumulative_total |floatformat:"2g"}}</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
        {% else %}
            <p class="center-text-view">You have no receipts</p>
        {% endif %}
    </main>
{% endblock content%}

receipts/templates/receipts/new.html
{% extends 'base.html' %}

{% block content %}
  <main class="center-text-view">
    <h1>Enter new receipt</h1>
    <p class="center-text-view">It is {% now "l, F jS, Y" %}</p>  
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Create Receipt</button>
    </form>
  </main>
{% endblock content %}